#include <stdio.h>
#include <stdarg.h>
#include <errno.h>
#include "common.h"

static char *program_name;

void set_program_name(char *s) {
    program_name = s;
}

void error(const char *format, ...) {
  va_list ap;
  fprintf(stderr, "%s: ", program_name);
  va_start(ap, format);
  vfprintf(stderr, format, ap);
  va_end(ap);
  fputc('\n', stderr);
}

void error_sys(const char *format, ...) {
  va_list ap;
  fprintf(stderr, "%s: ", program_name);
  va_start(ap, format);
  vfprintf(stderr, format, ap);
  va_end(ap);
  fprintf(stderr, "%s\n", strerror(errno));
}
