#include "ata.h"
#include "flashdisk.h"
#include "flashimgtool.h"

static struct flash_disk *flash_disk;

void ata_init(struct flash_disk *flash_disk_) {
    flash_disk = flash_disk_;
}

int ata_read_sectors(unsigned long start, int incount, void *inbuf) {
    DEBUGF("ata_read_sectors(%d, %d)\n", start, incount);
    while (incount > 0)
    {
        int done = flash_disk_read_sectors(flash_disk, start, incount, inbuf);
        if (done < 0)
            return -1;
        start += done;
        incount -= done;
        inbuf += SECTOR_SIZE * done;
    }
    return 0;
}

int ata_write_sectors(unsigned long start, int count, void *buf) {
    DEBUGF("ata_write_sectors(%d, %d)\n", start, count);
    while (count > 0)
    {
        int done = flash_disk_write_sectors(flash_disk, start, count, buf);
        if (done < 0)
            return -1;
        start += done;
        count -= done;
        buf += SECTOR_SIZE * done;
    }
    return 0;
}
