#ifndef _FLASHIMG_H_
#define _FLASHIMG_H_

#include <stdio.h>

#define FLASHIMG_256_8 0
#define FLASHIMG_512_8 1
#define FLASHIMG_1024_8 2

#define FLASHIMG_PAGE_DATA_SIZE 2048
#define FLASHIMG_PAGE_OOB_SIZE 64
#define FLASHIMG_PAGE_SIZE (FLASHIMG_PAGE_OOB_SIZE + FLASHIMG_PAGE_DATA_SIZE)

struct flashimg {
    int model;
    FILE *fp;
    size_t offset;
};

struct flashimg *flashimg_create(int model, char *fname, int offset);
void flashimg_free(struct flashimg *flash);
int flashimg_write(struct flashimg *flash, const char *buf,
                   int page, int start, int length);
int flashimg_read(struct flashimg *flash, char *buf,
                  int page, int start, int length);




#endif
